DebugFlag = 0

while true do
if memory.readbyte(0x7E0998) == 0x08 then
	local ChangedInput = memory.readshort(0x7E008F)
	if AND(memory.readshort(0x7E008B), 0x2000) ~= 0 then
		DebugFlag = XOR(DebugFlag, AND(ChangedInput, 0x0080))
		-- this shows the clipdata and BTS of every block on screen
	end

	local cameraX, cameraY = memory.readshort(0x7E0911), memory.readshort(0x7E0915)
	-- these are the co-ordinates of the top-left of the screen
	local width = memory.readshort(0x7E07A5)
	-- this is how wide the room is in blocks
	local tile = SHIFT(cameraX, 4) + SHIFT(cameraY, 4)*width
	-- each block is a 16x16 (thus the camera is divided by 16)

	slope = {
		[0x00] = function ()
			gui.box(TileX, TileY+8*VFlip, TileX+15*HFlip, TileY+15*VFlip, "clear", "green")
		end,
		[0x01] = function ()
			gui.box(TileX+8*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "clear", "green")
		end,
		[0x02] = function ()
			gui.box(TileX+8*HFlip, TileY+8*VFlip, TileX+15*HFlip, TileY+15*VFlip, "clear", "green")
		end,
		[0x03] = function ()
			gui.line(TileX+8*HFlip, TileY, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+8*HFlip, TileY, TileX+8*HFlip, TileY+7*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+8*VFlip, TileX+7*HFlip, TileY+8*VFlip, "green")
			gui.line(TileX, TileY+8*VFlip, TileX, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x05] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+7*HFlip, TileY+8*VFlip, "green")
			gui.line(TileX+8*HFlip, TileY+8*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x06] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+7*HFlip, TileY, "green")
			gui.line(TileX+8*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x07] = function ()
			gui.box(TileX, TileY+8*VFlip, TileX+15*HFlip, TileY+15*VFlip, "clear", "green")
		end,
		[0x0E] = function ()
			gui.line(TileX, TileY+13*VFlip, TileX+13*HFlip, TileY, "green")
			gui.line(TileX, TileY+13*VFlip, TileX, TileY+15*VFlip, "green")
			gui.line(TileX+13*HFlip, TileY, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x0F] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+5*HFlip, TileY+14*VFlip, "green")
			gui.line(TileX+6*HFlip, TileY+13*VFlip, TileX+9*HFlip, TileY+12*VFlip, "green")
			gui.line(TileX+10*HFlip, TileY+11*VFlip, TileX+11*HFlip, TileY+10*VFlip, "green")
			gui.line(TileX+12*HFlip, TileY+9*VFlip, TileX+13*HFlip, TileY+6*VFlip, "green")
			gui.line(TileX+14*HFlip, TileY+5*VFlip, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x12] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x13] = function ()
			gui.box(TileX, TileY, TileX+15*HFlip, TileY+15*VFlip, "clear", "green")
		end,
		[0x14] = function ()
			gui.line(TileX+8*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY+8*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY+8*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX+8*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x15] = function ()
			gui.line(TileX+8*HFlip, TileY, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+7*VFlip, TileX+7*HFlip, TileY, "green")
			gui.line(TileX, TileY+8*VFlip, TileX, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x16] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+8*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY+8*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x17] = function ()
			gui.line(TileX, TileY+7*VFlip, TileX+15*HFlip, TileY, "green")
			gui.line(TileX, TileY+8*VFlip, TileX, TileY+15*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x18] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+11*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY+11*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x19] = function ()
			gui.line(TileX, TileY+10*VFlip, TileX+15*HFlip, TileY+5*VFlip, "green")
			gui.line(TileX, TileY+10*VFlip, TileX, TileY+15*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY+5*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x1A] = function ()
			gui.line(TileX, TileY+4*VFlip, TileX+15*HFlip, TileY, "green")
			gui.line(TileX, TileY+4*VFlip, TileX, TileY+15*VFlip, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x1B] = function ()
			gui.line(TileX+8*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX+8*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x1C] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+7*HFlip, TileY, "green")
			gui.line(TileX+8*HFlip, TileY, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x1D] = function ()
			gui.line(TileX+10*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX+10*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x1E] = function ()
			gui.line(TileX+5*HFlip, TileY+15*VFlip, TileX+10*HFlip, TileY, "green")
			gui.line(TileX+10*HFlip, TileY, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX+5*HFlip, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end,
		[0x1F] = function ()
			gui.line(TileX, TileY+15*VFlip, TileX+5*HFlip, TileY, "green")
			gui.line(TileX+5*HFlip, TileY, TileX+15*HFlip, TileY, "green")
			gui.line(TileX+15*HFlip, TileY, TileX+15*HFlip, TileY+15*VFlip, "green")
			gui.line(TileX, TileY+15*VFlip, TileX+15*HFlip, TileY+15*VFlip, "green")
		end
	}
	outline = {
		[0x00] = function ()
		end, -- Air
		[0x01] = function ()
			local b = memory.readbyte(BTS)
			if AND(b, 0x40) ~= 0 then
				TileX = TileX+15
				HFlip = -1
			else
				HFlip = 1
			end
			-- Inverts the horizontal co-ordinates of the lines
			if AND(b, 0x80) ~= 0 then
				TileY = TileY+15
				VFlip = -1
			else
				VFlip = 1
			end
			-- Inverts the vertical co-ordinates of the lines
			slopefunction = slope[AND(memory.readbyte(BTS), 0x1F)] or function () gui.box(TileX, TileY, TileX+15*HFlip, TileY+15*VFlip, "clear", "purple") end
			slopefunction()
		end, -- Slope
		[0x02] = function ()
		end, -- Air, tricks X-ray
		[0x03] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
		end, -- Treadmill
		[0x05] = function ()
			stack = stack + 1
			if stack < 224 then
				local b = memory.readbytesigned(BTS)
				BTS = BTS + b
				Clip = Clip + SHIFT(b, -1)
				outlinefunction = outline[SHIFT(memory.readshort(Clip), 12)] or function() gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "purple") end
				outlinefunction()
			end
		end, -- Horizontal extend
		[0x08] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "red")
		end, -- Normal block
		[0x09] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
		end, -- Transition block
		[0x0A] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
		end, -- Spike block
		[0x0B] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
		end, -- Crumble block
		[0x0C] = function ()
			local b = memory.readbyte(BTS)
			if b >= 0x40 and b <= 0x43 then
				gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "orange")
			else
				gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
			end
		-- makes doors orange
		end, -- Shot block
		[0x0D] = function ()
			stack = stack + 1
			if stack < 224 then
				local b = memory.readbytesigned(BTS)
				BTS = BTS + b*width
				Clip = Clip + SHIFT(b*width, -1)
				outlinefunction = outline[SHIFT(memory.readshort(Clip), 12)] or function() gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "purple") end
				outlinefunction()
			end
		end, -- Vertical extend
		[0x0E] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
		end, -- Grapple block
		[0x0F] = function ()
			gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "blue")
		end -- Bomb block
	}

	for y=0,14 do
		for x=0,16 do
			stack = 0
			-- for when garbage data causes extend blocks that make infinate loops
			TileX, TileY = x*16 - AND(cameraX, 0x000F), y*16 - AND(cameraY, 0x000F)
			-- this if for pixel-aligning the grid, because the screen doesn't just scroll per block!
			a = tile + x + y*width
			-- get block's tile number
			BTS = 0x7F6402 + a
			-- BTS of block
			Clip = 0x7F0002 + a*2
			-- clipdata of block
			if DebugFlag ~= 0 then
				gui.text(TileX+4, TileY, string.format("%02X",SHIFT(memory.readshort(Clip), 12)), "red")
				--gui.text(TileX+4, TileY+4, string.format("%02X",AND(memory.readshort(Clip), 0x00FF)), "red")
				gui.text(TileX+4, TileY+8, string.format("%02X",memory.readbyte(BTS)), "red")
			end
			outlinefunction = outline[SHIFT(memory.readshort(Clip), 12)] or function() gui.box(TileX, TileY, TileX+15, TileY+15, "clear", "purple") end
			outlinefunction()
			-- that's for the block's clipdata nibble
		end
	end

	for i=0,31 do
		local enemyX, enemyY = memory.readshort(0x7E0F7A + i*64), memory.readshort(0x7E0F7E + i*64)
		local eradiusX, eradiusY = memory.readshort(0x7E0F82 + i*64), memory.readshort(0x7E0F84 + i*64)
		local topleft = {enemyX - cameraX - eradiusX, enemyY - cameraY - eradiusY}
		local bottomright = {enemyX - cameraX + eradiusX, enemyY - cameraY + eradiusY}
		gui.box(enemyX - cameraX - eradiusX, enemyY - cameraY - eradiusY, enemyX - cameraX + eradiusX, enemyY - cameraY + eradiusY, "clear", "#808080")
		-- draw enemy hitbox
		local enemyhealth = memory.readshort(0x7E0F8C + i*64)
		local enemyspawnhealth = memory.readshort(0xA00004 + memory.readshort(0x7E0F78 + i*64))
		if enemyspawnhealth ~= 0 then
			gui.text(topleft[1], topleft[2]-16, enemyhealth .. "/" .. enemyspawnhealth, "#808080")
			-- show enemy health
			if enemyhealth ~= 0 then
				gui.box(topleft[1], topleft[2]-8, topleft[1] + enemyhealth/enemyspawnhealth*32, topleft[2]-5, "#606060")
				gui.box(topleft[1], topleft[2]-8, topleft[1] + 32, topleft[2]-5, "clear", "#808080")
				-- draw enemy health bar
			end
		end
	end

	for i=0,9 do
		local projectileX, projectileY = memory.readshort(0x7E0B64 + i*2), memory.readshort(0x7E0B78 + i*2)
		local pradiusX, pradiusY = memory.readshort(0x7E0BB4 + i*2), memory.readshort(0x7E0BC8 + i*2)
		local topleft = {projectileX - cameraX - pradiusX, projectileY - cameraY - pradiusY}
		local bottomright = {projectileX - cameraX + pradiusX, projectileY - cameraY + pradiusY}
		gui.box(topleft[1],topleft[2], bottomright[1],bottomright[2], "clear", "#FFFF80")
		-- draw projectile hitbox

		gui.text(topleft[1], topleft[2]-8, memory.readshort(0x7E0C2C + i*2), "#FFFF80")
		-- show projectile damage
        if i >= 5 then
            gui.text(topleft[1], topleft[2]-16, memory.readbyte(0x7E0C7C + i*2), "#FFFF80")
        end
        -- show bomb timer
	end

	do
		local samusX, samusY = memory.readshort(0x7E0AF6), memory.readshort(0x7E0AFA)
		local radiusX, radiusY = memory.readshort(0x7E0AFE), memory.readshort(0x7E0B00)
		local topleft = {samusX - cameraX - radiusX, samusY - cameraY - radiusY}
		local bottomright = {samusX - cameraX + radiusX, samusY - cameraY + radiusY}
		gui.box(topleft[1],topleft[2], bottomright[1],bottomright[2], "clear", "#80FFFF")
		-- draw Samus' hitbox

		local cooldown = memory.readshort(0x7E0CCC)
		if cooldown ~= 0 then
			gui.text(bottomright[1], (topleft[2]+bottomright[2])/2-16, cooldown, "green")
		end
		-- show current cooldown time
        local charge = memory.readshort(0x7E0CD0)
        if charge ~= 0 then
            gui.text(bottomright[1], (topleft[2]+bottomright[2])/2-8, charge, "green")
        end
        -- show current beam charge
        local recoil, invincibility = memory.readshort(0x7E18AA), memory.readshort(0x7E18A8)
        if recoil ~= 0 then
            gui.text(bottomright[1], (topleft[2]+bottomright[2])/2, recoil, "cyan")
        elseif invincibility ~= 0 then
            gui.text(bottomright[1], (topleft[2]+bottomright[2])/2, invincibility, "cyan")
        end
        -- show recoil/invincibility
        local shine = memory.readbyte(0x7E0A68)
        if shine ~= 0 then
            gui.text(bottomright[1], (topleft[2]+bottomright[2])/2+8, shine, "cyan")
        end
        
        gui.text(topleft[1], topleft[2]-16, string.format("%X.%04X", memory.readshort(0x7E0B42), memory.readshort(0x7E0B44)), "#00FFFF")
        -- show horizontal speed
        gui.text(topleft[1], topleft[2]-8, string.format("%X.%04X", memory.readshort(0x7E0B46), memory.readshort(0x7E0B48)), "#00FFFF")
        -- show horizontal momentum
        gui.text(topleft[1], bottomright[2], string.format("%X.%04X", memory.readshort(0x7E0B2E), memory.readshort(0x7E0B2C)), "#00FFFF")
        -- show vertical speed
        gui.text(topleft[1], bottomright[2]+8, memory.readbyte(0x7E0B3F), "#00FFFF")
        -- show speed booster level
	end
    
    gui.text(216, 0, string.format("%d:%d:%d.%d", memory.readshort(0x7E09E0), memory.readshort(0x7E09DE), memory.readshort(0x7E09DC), memory.readshort(0x7E09DA)), "#FFFFFF")
end
	snes9x.frameadvance()
end
